using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.IO;
using Ini;
using System.Windows.Forms;





namespace ClientTest1
{
    class Program
    {

        static Socket serversocket;
        static Socket clientsock;
        static Socket Trackersock;

        static Process IndigoProcess;

        static string MasterIP;

        static string TrackerName;
        static string IndigoFullPath;
    

        static bool RunIndigo()
        {

            bool status = true;

            try
            {
                IndigoProcess = new Process();

                //IndigoProcess.StartInfo.FileName = @"c:\indigo\indigo.exe";
                IndigoProcess.StartInfo.FileName = IndigoFullPath;
                IndigoProcess.StartInfo.Arguments = "remoterender.xml " + "-n s -h " + MasterIP + ":7777";


                string IndigoTempPath = IndigoFullPath;
                int SlashPos = IndigoTempPath.LastIndexOf('\\');
                IndigoTempPath = IndigoTempPath.Substring(0, SlashPos);

                
                IndigoProcess.StartInfo.WorkingDirectory = IndigoTempPath;


                IndigoProcess.Start();
            }
            catch (System.Exception e)
            {
                status = false;
                IndigoProcess.Close();

                IndigoProcess = null;


            }

            return status;

        }



        static void listenclient()
        {

            Socket LocalSock = clientsock;


            Console.WriteLine("Client connected..\n");
            Console.WriteLine("Client at: " + LocalSock.RemoteEndPoint.ToString());

            string ClientIP = LocalSock.RemoteEndPoint.ToString();

            string[] IPSplit = ClientIP.Split(':');

            MasterIP = IPSplit[0];

            string CurrentCommand = "";

            try
            {


                while (LocalSock.Connected == true)
                {

                    byte[] recs = new byte[32767];
                    int rcount = LocalSock.Receive(recs, recs.Length, 0);

                    if (rcount != 0)
                    {

                        string clientmessage = System.Text.Encoding.ASCII.GetString(recs);
                        clientmessage = clientmessage.Substring(0, rcount);

                        Console.WriteLine("Command: " + clientmessage);

                        CurrentCommand = clientmessage;

                        // Test current command string
                        if (CurrentCommand != "")
                        {
                            // We need to handle disconnect messages here,
                            // as well as rendering messages, such as:
                            // BEGINRENDER
                            // CANCELRENDER
                            // UPLOADRENDERDATA
                           
                            if (CurrentCommand == "BEGINRENDER")
                            {
                                // I'm only going to allow one process at a time right now

                                if (IndigoProcess != null)
                                {

                                    byte[] ErrMessage = System.Text.ASCIIEncoding.ASCII.GetBytes("Already Running");

                                    LocalSock.Send(ErrMessage, ErrMessage.Length, 0);


                                }
                                else
                                {
                                    if (RunIndigo() == false)
                                    {
                                        byte[] ErrMessage2 = System.Text.ASCIIEncoding.ASCII.GetBytes("Failed to launch Indigo");

                                        LocalSock.Send(ErrMessage2, ErrMessage2.Length, 0);


                                    }
                                    else
                                    {
                                        byte[] Message3 = System.Text.ASCIIEncoding.ASCII.GetBytes("Rendering...");

                                        LocalSock.Send(Message3, Message3.Length, 0);


                                    }

                                }


                            }


                            if (CurrentCommand.Contains("UPLOADRENDERDATA"))
                            {


                               
                                // parse command 
                                if (CurrentCommand.Contains(";"))
                                {


                                    string[] Parsed = CurrentCommand.Split(';');
                                    string SizeString = Parsed[1];
                                    long FileSize = int.Parse(SizeString);
                                    string FileName = Parsed[2];


                                    // Tell the server we are ready..
                                    byte[] Message5 = System.Text.ASCIIEncoding.ASCII.GetBytes("UPLOADSTART");

                                    LocalSock.Send(Message5, Message5.Length, 0);

                                    // start downloading
                                    CLIENT_DOWNLOADING(FileName, FileSize, LocalSock);

                                    byte[] Message3 = System.Text.ASCIIEncoding.ASCII.GetBytes("RENDERDATARECEIVED");

                                    LocalSock.Send(Message3, Message3.Length, 0);
                                } else
                                {
                                    byte[] Message3 = System.Text.ASCIIEncoding.ASCII.GetBytes("Render data - file size not specified correctly");

                                    LocalSock.Send(Message3, Message3.Length, 0);
                                }


                            }




                            if (CurrentCommand == "CANCELRENDER")
                            {

                                if (IndigoProcess != null)
                                {
                                    try
                                    {
                                        IndigoProcess.Kill();

                                        IndigoProcess.Close();

                                        IndigoProcess = null;

                                    }
                                    catch (System.Exception e)
                                    {
                                    	// nothing
                                        IndigoProcess = null;

                                    }
                                    
                                    byte[] Message4 = System.Text.ASCIIEncoding.ASCII.GetBytes("Render Cancelled. ");

                                    LocalSock.Send(Message4, Message4.Length, 0);


                                }


                            }


                        }


                    }

                    else
                    {
                        Console.WriteLine("Remote connection was closed..");
                        LocalSock.Shutdown(SocketShutdown.Both);
                        LocalSock.Close();
                       


                    }
                }
            }
            catch (System.Exception e)
            {

                Console.WriteLine(e.Message);

                if (LocalSock != null)
                {
                    LocalSock.Shutdown(SocketShutdown.Both);
                    LocalSock.Close();
               

                }
            
            }

        }



        static void CLIENT_DOWNLOADING(string FileName, long FileSize, Socket s)
        {

            Console.WriteLine("Receiving render data...");

            Socket sock = s;
        
            // swap out file name
            if (FileName.ToLower().Contains(".xml") || FileName.ToLower().Contains(".igs"))
            {
                // strip out after last slash, replace filename with remoterender.xml
                int SlashPos = FileName.LastIndexOf('\\');

                FileName = FileName.Substring(0, SlashPos);
                FileName += "\\remoterender.xml";


            }

            // create the path if it does not exist
            int SlashPos1 = FileName.LastIndexOf('\\');
            string FilePath = FileName.Substring(0, SlashPos1);

            if (Directory.Exists(FilePath) == false)
            {
                Directory.CreateDirectory(FilePath);

            }


            FileStream fout = new FileStream(FileName, FileMode.Create, FileAccess.Write);
            NetworkStream nfs = new NetworkStream(sock);
            
            // for testing right now...

            long size = FileSize;

            long rby = 0;
    
     

            try
            {
                //loop till the Full bytes have been read
                while (rby < size)
                {
                    byte[] buffer = new byte[1024];
                    //Read from the Network Stream
                    int i = nfs.Read(buffer, 0, buffer.Length);
                    fout.Write(buffer, 0, (int)i);
                    rby = rby + i;

                    int pc = (int)(((double)rby / (double)size) * 100.00);
                    string perc = pc.ToString() + "%";

                   

                }
                fout.Close();

                Console.WriteLine("Receive finished.");

                nfs.Close(0);

               
            }
            catch (Exception ed)
            {
                Console.WriteLine("A Exception occurred in file transfer" + ed.ToString());
                nfs.Close(0);

                
            }


        }




        static void TrackerTalk()
        {
            do
            {
                if (Trackersock == null)
                {
                    // launch a seperate thread to connect to the main server
                    Console.WriteLine("Attempting to connect to tracker..");

                    try
                    {
                        Trackersock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                        IPHostEntry IPHost1 = Dns.GetHostEntry(TrackerName);

                        
                        string[] aliases1 = IPHost1.Aliases;
                        IPAddress[] addr1 = IPHost1.AddressList;

                        IPEndPoint ipepServer1 = new IPEndPoint(addr1[0], 8090);

                        Console.WriteLine("Connecting to tracker at: [" + addr1[0].ToString() + "]");


                        Trackersock.Connect(ipepServer1);

                        // inform the server that we are a client rendering engine

                        byte[] ClientInform = System.Text.ASCIIEncoding.ASCII.GetBytes("CLIENTRENDER");

                        Trackersock.Send(ClientInform, ClientInform.Length, 0);

                        // wait for data to come back

                        // if we get zero data back, then this means the other end disconnected
                        // so we have to disconnect as well
                        // we will then re-connect automatically every 5 seconds
                        // (we try to re-connect)
                           byte[] recs = new byte[2000];
                           int rcount = Trackersock.Receive(recs, recs.Length, 0);

                           if (rcount == 0)
                           {
                               Trackersock.Shutdown(SocketShutdown.Both);
                               Trackersock.Close();
                               Trackersock = null;


                           }

                    }
                    catch (Exception ez)
                    {
                        Console.WriteLine("Failed to connect to tracker: \n" + ez.Message);

                        if (Trackersock != null)
                        {
                            //Trackersock.Shutdown(SocketShutdown.Both);
                            Trackersock.Close();
                            Trackersock = null;
                        }

                    }


                }
               
               // wait a bit, and try to reconnect...
               Thread.Sleep(25000);


            } while (true);



        }


        static void Main(string[] args)
        {
         
            // Load Settings first
            IniFile TempIni = new IniFile(Application.StartupPath + "\\ClientSettings.ini");

            IndigoFullPath = TempIni.IniReadValue("SETTINGS", "IndigoPath");
            TrackerName = TempIni.IniReadValue("SETTINGS", "Tracker");

            if ((IndigoFullPath == "") || (TrackerName ==""))
            {

                Console.WriteLine("Error! Could not load tracker and indigo path settings from INI file");
                Console.WriteLine("Please edit the INI file for your system and restart the render client");
                return;

            }

            
            // Start a new thread to talk to the main server,
            // always attempts to also auto-reconnect too
            Thread TrackerTalker = new Thread(new ThreadStart(TrackerTalk));
            TrackerTalker.Start();

            try
            {
                serversocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                IPHostEntry IPHost = Dns.GetHostEntry(Dns.GetHostName());

                string[] aliases = IPHost.Aliases;
                IPAddress[] addr = IPHost.AddressList;

                IPEndPoint ipepServer = new IPEndPoint(addr[0], 5200);
                serversocket.Bind(ipepServer);
                serversocket.Listen(-1);

                while (true)
                {

                    clientsock = serversocket.Accept();
                    if (clientsock.Connected)
                    {

                        // launch a new thread to handle this client
                        Thread tc = new Thread(new ThreadStart(listenclient));
                        tc.Start();
                    }
                }
            }
            catch (Exception ez)
            {
                Console.WriteLine("Could not start client. " + ez.Message);


            }
      
      

        }
    }
}
