using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Threading;
using System.Xml;
using System.Xml.XPath;
using Ini;



namespace MasterRender1
{

 

    public partial class Form1 : Form
    {

        Process IndigoProcess;
        bool IndigoRunning;
        string IndigoFileName;
        long IndigoFileSize;

        string LocalHostAddress;
         

        Thread UploadThread;

     
        // for talking to the UI during threaded operations.
        delegate void SetViewProgressDelegate(string IP, int value);
        delegate void SetViewMessageDelegate(string IP, string msg);
        delegate void SetUploadNameDisplayDelegatge(string UploadedFile);

        

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            dataGridView1.Rows.Clear();
            label2.Text = "Current rendering scene: None";

            LoadSettings();


        }


        private void SaveSettings()
        {
            IniFile TempIni = new IniFile(Application.StartupPath + "\\MasterSettings.ini");

            TempIni.IniWriteValue("SETTINGS", "Tracker", textBox1.Text);
            TempIni.IniWriteValue("SETTINGS", "IndigoPath", textBox2.Text);

        }


        private void LoadSettings()
        {
            IniFile TempIni = new IniFile(Application.StartupPath + "\\MasterSettings.ini");

            textBox1.Text = TempIni.IniReadValue("SETTINGS", "Tracker");
            textBox2.Text = TempIni.IniReadValue("SETTINGS", "IndigoPath");



        }

        private void SetUploadLabel(string LabelText)
        {

            if (InvokeRequired == true)
            {
                BeginInvoke(new SetUploadNameDisplayDelegatge(SetUploadLabel), LabelText);
                return;
            }

            label2.Text = LabelText;



        }
      

        private void SetViewProgress(string IP, int value)
        {

            if (InvokeRequired == true)
            {

                BeginInvoke(new SetViewProgressDelegate(SetViewProgress), new object[] { IP, value });

                return;
            }


            // search for IP, then set progressbar value
            for (int jj = 0; jj < dataGridView1.Rows.Count; jj++)
            {

                if (dataGridView1.Rows[jj].Cells["Column1"].Value.ToString() == IP)
                {

                    dataGridView1.Rows[jj].Cells["Column3"].Value = value;


                }

            }


        }


        private void SetViewMessage(string IP, string Msg)
        {

            if (InvokeRequired == true)
            {

                BeginInvoke(new SetViewMessageDelegate(SetViewMessage), new object[] { IP, Msg });

                return;
            }


            // search for IP, then set progressbar value
            for (int jj = 0; jj < dataGridView1.Rows.Count; jj++)
            {

                if (dataGridView1.Rows[jj].Cells["Column1"].Value.ToString() == IP)
                {

                    dataGridView1.Rows[jj].Cells["Column2"].Value = Msg;


                }

            }


        }



       

   

        private void DoUpload()
        {
            // loop thru all client entries

            // first find out what our local host address is,
            // because if we are running a client on the master as well,
            // we don't want to upload there, since that is where the files
            // are coming from!

            IPHostEntry IPHost = Dns.GetHostEntry(Dns.GetHostName());

            string[] aliases = IPHost.Aliases;
            IPAddress[] addr = IPHost.AddressList;

            LocalHostAddress = addr[0].ToString();

            string FileThatWasUploaded;
         
            for (int ii=0;ii < dataGridView1.Rows.Count;ii++)

            {
                // current remote server 
                string CurrentHost = dataGridView1.Rows[ii].Cells["Column1"].Value.ToString();

                if (CurrentHost != "")
                {

                 
                    long IndigoFileSizeTemp = IndigoFileSize;
                    string IndigoFileNameTemp = IndigoFileName;

                    FileThatWasUploaded = IndigoFileNameTemp;
                    
                    // build a list of files to upload, and their filenames..
                    List<string> FilesToUpload = new List<string>();
                    List<long> FileSizesToUpload = new List<long>();


                    // first file to always upload is the render file itself.
                    FilesToUpload.Add(IndigoFileNameTemp);
                    FileSizesToUpload.Add(IndigoFileSizeTemp);

                    
                    int SlashPos = IndigoFileNameTemp.LastIndexOf('\\');
                    string IndigoPath = IndigoFileNameTemp.Substring(0, SlashPos);


                    // we need to scan  the indigo XML file to see if there are any
                    // texture images that need to be uploaded

                    XPathNavigator nav;
                    XPathDocument docNav;
                    XPathNodeIterator NodeIter;
                    String strExpression;

                    // only add files to be uploaded/copied, if this is a remote
                    // system, and not if this is the uploading system
                    if (CurrentHost != LocalHostAddress)
                    {



                        // Open the XML.
                        docNav = new XPathDocument(IndigoFileNameTemp);

                        // Create a navigator to query with XPath.
                        nav = docNav.CreateNavigator();

                        strExpression = "//path";

                        NodeIter = nav.Select(strExpression);

                        while (NodeIter.MoveNext())
                        {
                            string NextFile = NodeIter.Current.Value;

                            string Testval = NextFile.ToLower().Substring(1, 1);

                            // if the filename does not start with C: or D:, etc,
                            // then we have to tack on the current path to it

                            if (Testval != ":")
                            {
                                NextFile = IndigoPath + "\\" + NextFile;

                            }

                            FilesToUpload.Add(NextFile);

                            FileInfo fi = new FileInfo(NextFile);

                            FileSizesToUpload.Add(fi.Length);



                        };

                    }

                    // get the current directory
                    for (int uu = 0; uu < FilesToUpload.Count; uu++)
                    {
                                             


                        IndigoFileSizeTemp = FileSizesToUpload[uu];
                        IndigoFileNameTemp = FilesToUpload[uu];

                                              

                        SetUploadLabel(IndigoFileNameTemp);

                        try
                        {
                                                      
                            // tell the remote server that we are about to upload data
                            byte[] command = Encoding.UTF8.GetBytes("UPLOADRENDERDATA;" + IndigoFileSizeTemp.ToString() + ";" + IndigoFileNameTemp);
                            
                            Socket rendersocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                            rendersocket.LingerState = new LingerOption(false, 0);
                            
                            IPHostEntry IPHost1 = Dns.GetHostEntry(CurrentHost);
                            string[] aliases1 = IPHost1.Aliases;
                            IPAddress[] addr1 = IPHost1.AddressList;

                            IPEndPoint ipepServer1 = new IPEndPoint(addr1[0], 5200);

                            rendersocket.Connect(ipepServer1);


                            rendersocket.Send(command, command.Length, SocketFlags.None);

                                                       

                            byte[] recs = new byte[32767];
                            int rcount = rendersocket.Receive(recs, SocketFlags.None);

                            if (rcount > 0)
                            {
                                
                                string clientmessage = System.Text.Encoding.ASCII.GetString(recs);
                                clientmessage = clientmessage.Substring(0, rcount);

                                if (clientmessage == "UPLOADSTART")
                                {
                                    
                                    SetViewMessage(CurrentHost, "Uploading..");

                                    System.Threading.Thread.Sleep(1000);


                                    //  start sending the render data...


                                    SERVER_DOWNLOADING(CurrentHost, IndigoFileNameTemp, IndigoFileSizeTemp, rendersocket);

                                    // now get the response. These are blocking calls,
                                    // so it will wait here until there is a response.

                                    byte[] recs1 = new byte[32767];
                                    int rcount1 = rendersocket.Receive(recs1, SocketFlags.None);

                                    string clientmessage1 = System.Text.Encoding.ASCII.GetString(recs1);
                                    clientmessage1 = clientmessage1.Substring(0, rcount1);

                                 
                                    SetViewMessage(CurrentHost, clientmessage1);



                                }

                            }

                            rendersocket.Shutdown(SocketShutdown.Both);
                            rendersocket.Disconnect(false);
                            rendersocket.Close();




                        }
                        catch (Exception ex)
                        {
                            //MessageBox.Show(ex.Message);
                            SetViewMessage(CurrentHost, ex.Message);

                        }
                    }

                    SetUploadLabel("Current rendering scene: " + FileThatWasUploaded);

                  
                }

                if (CurrentHost == LocalHostAddress)
                {

                    SetViewMessage(CurrentHost, "System is file source");
                    



                }


            }




        }



        private void button1_Click(object sender, EventArgs e)
        {

            //listBox1.Items.Clear();
            dataGridView1.Rows.Clear();


            long gridcount = 0;


            try
            {
                Socket rendersocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                rendersocket.LingerState = new LingerOption(false, 0);
               

                IPHostEntry IPHost1 = Dns.GetHostEntry(textBox1.Text);

                string[] aliases1 = IPHost1.Aliases;
                IPAddress[] addr1 = IPHost1.AddressList;

                IPEndPoint ipepServer1 = new IPEndPoint(addr1[0], 8090);

                rendersocket.Connect(ipepServer1);

                // we need to get the list of render clients available
                // each client will have a port on 5200 waiting for us to command it
                byte[] command = Encoding.UTF8.GetBytes("CLIENTLIST");

                rendersocket.Send(command, command.Length, SocketFlags.None);

                // now get the response. These are blocking calls,
                // so it will wait here until there is a response.

                byte[] recs = new byte[32767];
                int rcount = rendersocket.Receive(recs, recs.Length,SocketFlags.None);

                if (rcount > 0)
                {
                    string clientmessage = System.Text.Encoding.ASCII.GetString(recs);
                    clientmessage = clientmessage.Substring(0, rcount);

                    if ((clientmessage != "") && (clientmessage != "CLIENTLIST+"))
                    {
                        // this should be the client list, so split it up and display it
                        string[] Junk = clientmessage.Split('+');
                        string[] ClientList = Junk[1].Split(',');

                        foreach (string SubClient in ClientList)
                        {
                            string[] SubClientData = SubClient.Split(':');

                            if (SubClientData[0] != "")
                            {
                               
                               object[] rows = new object[]{SubClientData[0].ToString(),"Ready",0};

                               dataGridView1.Rows.Add(rows);
                                
                            }

                            gridcount++;

                        }
                    }
                }
               
                rendersocket.Shutdown(SocketShutdown.Both);
                rendersocket.Disconnect(false);
                rendersocket.Close();

                
               

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);

            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

            // run the master indigo process if it's not already running

            if (IndigoRunning == false)
            {
                IndigoRunning = RunIndigo();
            }


             
            for (int ii = 0; ii < dataGridView1.Rows.Count; ii++)
            {
                string CurrentHost = dataGridView1.Rows[ii].Cells["Column1"].Value.ToString();

                if (CurrentHost != "")
                {

                    try
                    {
                        Socket rendersocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                        rendersocket.LingerState = new LingerOption(false, 0);


                        IPHostEntry IPHost1 = Dns.GetHostEntry(CurrentHost);

                        string[] aliases1 = IPHost1.Aliases;
                        IPAddress[] addr1 = IPHost1.AddressList;

                        IPEndPoint ipepServer1 = new IPEndPoint(addr1[0], 5200);

                        rendersocket.Connect(ipepServer1);

                        // we need to get the list of render clients available
                        // each client will have a port on 5200 waiting for us to command it
                        byte[] command = Encoding.UTF8.GetBytes("BEGINRENDER");

                        rendersocket.Send(command, command.Length, SocketFlags.None);

                        // now get the response. These are blocking calls,
                        // so it will wait here until there is a response.

                        byte[] recs = new byte[32767];
                        int rcount = rendersocket.Receive(recs, SocketFlags.None);

                        string clientmessage = System.Text.Encoding.ASCII.GetString(recs);
                        clientmessage = clientmessage.Substring(0, rcount);


                        SetViewMessage(CurrentHost,clientmessage);

                        rendersocket.Shutdown(SocketShutdown.Both);
                        rendersocket.Disconnect(false);
                        rendersocket.Close();




                    }
                    catch (Exception ex)
                    {
                      
                        SetViewMessage(CurrentHost,ex.Message);
                        

                    }
                }
            }
           

        }

        private void button3_Click(object sender, EventArgs e)
        {

            // tell all clients to kill their rendering

            for (int ii = 0; ii < dataGridView1.Rows.Count; ii++)
            {
                string CurrentHost = dataGridView1.Rows[ii].Cells["Column1"].Value.ToString();

                if (CurrentHost != "")
                {

                    try
                    {
                        Socket rendersocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                        rendersocket.LingerState = new LingerOption(false, 0);


                        IPHostEntry IPHost1 = Dns.GetHostEntry(CurrentHost);

                        string[] aliases1 = IPHost1.Aliases;
                        IPAddress[] addr1 = IPHost1.AddressList;

                        IPEndPoint ipepServer1 = new IPEndPoint(addr1[0], 5200);

                        rendersocket.Connect(ipepServer1);

                        // we need to get the list of render clients available
                        // each client will have a port on 5200 waiting for us to command it
                        byte[] command = Encoding.UTF8.GetBytes("CANCELRENDER");

                        rendersocket.Send(command, command.Length, SocketFlags.None);

                        // now get the response. These are blocking calls,
                        // so it will wait here until there is a response.

                        byte[] recs = new byte[32767];
                        int rcount = rendersocket.Receive(recs, SocketFlags.None);

                        string clientmessage = System.Text.Encoding.ASCII.GetString(recs);
                        clientmessage = clientmessage.Substring(0, rcount);

                      
                        SetViewMessage(CurrentHost, clientmessage);




                        rendersocket.Shutdown(SocketShutdown.Both);
                        rendersocket.Disconnect(false);
                        rendersocket.Close();

                        if ((IndigoProcess != null) && (IndigoRunning == true))
                        {
                            try
                            {
                                IndigoProcess.Kill();

                                IndigoProcess.Close();

                                IndigoProcess = null;
                                IndigoRunning = false;


                            }
                            catch (System.Exception el)
                            {
                                // nothing
                                IndigoProcess = null;
                                IndigoRunning = false;

                            }
                        }


                    }
                    catch (Exception ex)
                    {
                       
                        SetViewMessage(CurrentHost, ex.Message);


                    }
                }
            }
        }




        private void SERVER_DOWNLOADING(string IP, string FileName, long FileSize, Socket s)
        {


                try
                {

                    Socket sock = s;
                    long rdby = 0;
                    int len = 0;

                    byte[] buffed = new byte[1024];
                    //Open the file requested for download 
                    FileStream fin = new FileStream(FileName, FileMode.Open, FileAccess.Read);
                    //One way of transfer over sockets is Using a NetworkStream 
                    //It provides some useful ways to transfer data 
                    NetworkStream nfs = new NetworkStream(sock);

                    while (rdby < FileSize && nfs.CanWrite)
                    {
                        //Read from the File (len contains the number of bytes read)
                        len = fin.Read(buffed, 0, buffed.Length);
                        //Write the Bytes on the Socket
                        nfs.Write(buffed, 0, len);
                        //Increase the bytes Read counter
                        rdby = rdby + len;

                      

                        int pc = (int)(((double)rdby / (double)FileSize) * 100.00);
                        string perc = pc.ToString() + "%";

                        SetViewProgress(IP, pc);



                    }
                    
                    fin.Close();


                }
                catch (Exception ed)
                {
                   
                    MessageBox.Show("An exception occurred in file transfer" + ed.ToString());


                }
            

           

        }


        private bool RunIndigo()
        {

            bool status = true;

            if (IndigoRunning == false)
            {


                try
                {
                    IndigoProcess = new Process();

                    //IndigoProcess.StartInfo.FileName = @"c:\indigo\indigo.exe";
                    IndigoProcess.StartInfo.FileName = textBox2.Text;
                    IndigoProcess.StartInfo.Arguments = IndigoFileName + " -n m";
                    //IndigoProcess.StartInfo.WorkingDirectory = @"C:\indigo";

                    string IndigoPathOnly = textBox2.Text;
                    int SlashPos = IndigoPathOnly.LastIndexOf('\\');
                    IndigoPathOnly = IndigoPathOnly.Substring(0, SlashPos);

                    IndigoProcess.StartInfo.WorkingDirectory = IndigoPathOnly;

                    IndigoProcess.Start();
                }
                catch (System.Exception e)
                {
                    status = false;
                    IndigoProcess.Close();

                    IndigoProcess = null;


                }
            }
            else
                status = false;


            return status;

        }


        private void button4_Click(object sender, EventArgs e)
        {

            DialogResult dr = openFileDialog1.ShowDialog();

            if (dr != DialogResult.Cancel)
            {

                string FileToSend = openFileDialog1.FileName;

                if (FileToSend != "")
                {

                    // get the file info for the file we want to upload...
                    FileInfo fi = new FileInfo(FileToSend);

                    IndigoFileName = FileToSend;


                    IndigoFileSize = fi.Length;

                    UploadThread = new Thread(new ThreadStart(DoUpload));

                    UploadThread.Start();



                }

            }

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox1_Leave(object sender, EventArgs e)
        {

            SaveSettings();


        }

        private void textBox2_Leave(object sender, EventArgs e)
        {
            SaveSettings();

        }
    }
}


#region ProgressBarInDataGridView

public class ProgressColumn : DataGridViewColumn
{
    public ProgressColumn()
        : base(new ProgressCell())
    {
    }

    public override DataGridViewCell CellTemplate
    {
        get
        {
            return base.CellTemplate;
        }
        set
        {
            // Ensure that the cell used for the template is a ProgressCell.
            if (value != null &&
                !value.GetType().IsAssignableFrom(typeof(ProgressCell)))
            {
                throw new InvalidCastException("Must be a ProgressCell");
            }
            base.CellTemplate = value;
        }
    }
}

// Classes to draw the progress bar in the DataGridView control

public class ProgressCell : DataGridViewImageCell
{
    protected override object GetFormattedValue(object value, int rowIndex, ref DataGridViewCellStyle cellStyle, TypeConverter valueTypeConverter, TypeConverter formattedValueTypeConverter, DataGridViewDataErrorContexts context)
    {
        // Create bitmap.
        Bitmap bmp = new Bitmap(this.Size.Width, this.Size.Height);

        using (Graphics g = Graphics.FromImage(bmp))
        {
            // Percentage.
            double percentage = 0;
            double.TryParse(this.Value.ToString(), out percentage);
            string text = percentage.ToString() + " %";

            // Get width and height of text.
            Font f = new Font("Verdana", 10, FontStyle.Regular);
            int w = (int)g.MeasureString(text, f).Width;
            int h = (int)g.MeasureString(text, f).Height;

            // Draw pile.
            g.DrawRectangle(Pens.Black, 2, 2, this.Size.Width - 6, this.Size.Height - 6);
            g.FillRectangle(Brushes.Blue, 3, 3, (float)((this.Size.Width - 6) * percentage / 100), this.Size.Height - 7);

            RectangleF rect = new RectangleF(0, 0, bmp.Width, bmp.Height);
            StringFormat sf = new StringFormat();
            sf.Alignment = StringAlignment.Center;
            g.DrawString(text, f, Brushes.Red, rect, sf);
        }

        return bmp;
    }

#endregion

}